package servlets;

import java.io.IOException;
import javax.servlet.ServletException;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import negocio.exception.UsuarioInexistenteException;
import negocio.exception.UsuarioNaoLogadoException;
import negocio.exception.UsuarioSemPermissaoException;

import dados.usuario.Cliente;
import dados.usuario.Dependente;
import dados.usuario.Funcionario;
import dados.usuario.Usuario;
import exception.ServidorIndisponivelException;
import fachada.Fachada;

/**
 * Servlet implementation class AlterarDados
 */
public class AlterarDados extends HttpServlet {
	private static final long serialVersionUID = 1L;

	public AlterarDados() {
		super();
	}

	protected void doGet(HttpServletRequest request, HttpServletResponse response) throws ServletException, IOException {
		try {
			if(request.getParameter("cpf") != null){
				Usuario user = Fachada.getFachada().getUsuario((Long) request.getSession().getAttribute("sessao"), Long.parseLong(request.getParameter("cpf")));
				
				if(user instanceof Cliente){
					response.sendRedirect("alterar-cliente.jsp?cpf="+request.getParameter("cpf"));
				} else {
					String tipo = null;
					if(user instanceof Funcionario){
						tipo = "funcionario";
					} else if(user instanceof Dependente){
						tipo = "dependente";
					} else {
						tipo = "administrador";
					}
					response.sendRedirect("alterar-usuario.jsp?tipo="+tipo + "&cpf="+request.getParameter("cpf"));
				}
			} else {
				response.sendRedirect("cadastro-erro.jsp?tipo=usuario&erro=campo");
			}
		} catch (NumberFormatException e) {
			response.sendRedirect("cadastro-erro.jsp?erro=campo");
		} catch (UsuarioNaoLogadoException e) {
			response.sendRedirect("cadastro-erro.jsp?tipo=produto&erro=usuarioNaoLogado");
		} catch (UsuarioInexistenteException e) {
			response.sendRedirect("cadastro-erro.jsp?erro=usuarioInexistente");
		} catch (UsuarioSemPermissaoException e) {
			e.printStackTrace();
			response.sendRedirect("index.jsp");
		} catch (ServidorIndisponivelException e) {
			response.sendRedirect("erro-servidor.jsp");
		}
	}

	protected void doPost(HttpServletRequest request, HttpServletResponse response) throws ServletException, IOException {
		this.doGet(request, response);
	}

}
