package servlets;

import java.io.IOException;
import javax.servlet.ServletException;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import negocio.exception.FilialInexistenteException;
import dados.filial.Filial;
import exception.ServidorIndisponivelException;
import fachada.Fachada;

/**
 * Servlet implementation class AlterarDadosFilial
 */
public class AlterarDadosFilial extends HttpServlet {
	private static final long serialVersionUID = 1L;
       
    public AlterarDadosFilial() {
        super();
    }

	protected void doGet(HttpServletRequest request, HttpServletResponse response) throws ServletException, IOException {
		try {
			if(request.getParameter("nome") != null && !request.getParameter("nome").isEmpty()){
				Filial p = Fachada.getFachada().getFilial(request.getParameter("nome"));
				
				String resposta = "alterar-filial.jsp?id="+p.getId();
				response.sendRedirect(resposta);
			} else {
				response.sendRedirect("cadastro-erro.jsp?tipo=filial&erro=campo");
			}
		} catch (ServidorIndisponivelException e) {
			response.sendRedirect("erro-servidor.jsp");
		} catch (FilialInexistenteException e) {
			response.sendRedirect("cadastro-erro.jsp?erro=filialInexistente");
		}
	}

	protected void doPost(HttpServletRequest request, HttpServletResponse response) throws ServletException, IOException {
		this.doGet(request, response);
	}

}
