package servlets;

import java.io.IOException;
import javax.servlet.ServletException;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import negocio.exception.PlanoInexistenteException;

import dados.usuario.Plano;
import exception.ServidorIndisponivelException;

import fachada.Fachada;

/**
 * Servlet implementation class AlterarDadosPlano
 */
public class AlterarDadosPlano extends HttpServlet {
	private static final long serialVersionUID = 1L;
       
    public AlterarDadosPlano() {
        super();
    }

	protected void doGet(HttpServletRequest request, HttpServletResponse response) throws ServletException, IOException {
		if(request.getParameter("nome") != null && !request.getParameter("nome").isEmpty()){
			try {
				Plano p = Fachada.getFachada().buscarPlano(request.getParameter("nome"));
				response.sendRedirect("alterar-plano.jsp?plano=" + p.getId());
			} catch (PlanoInexistenteException e) {
				response.sendRedirect("cadastro-erro.jsp?erro=planoInexistente");
			} catch (ServidorIndisponivelException e) {
				response.sendRedirect("erro-servidor.jsp");
			}
		} else {
			response.sendRedirect("cadastro-erro.jsp?tipo=plano&erro=campo");			 
		}
	}

	protected void doPost(HttpServletRequest request, HttpServletResponse response) throws ServletException, IOException {
		this.doGet(request, response);
	}

}
