package servlets;

import java.io.IOException;
import javax.servlet.ServletException;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import negocio.exception.ProdutoInexistenteException;
import dados.produto.Documentario;
import dados.produto.Filme;
import dados.produto.Jogo;
import dados.produto.Musica;
import dados.produto.Produto;
import dados.produto.Serie;
import exception.ServidorIndisponivelException;
import fachada.Fachada;

/**
 * Servlet implementation class AlterarDadosProduto
 */
public class AlterarDadosProduto extends HttpServlet {
	private static final long serialVersionUID = 1L;
       
    public AlterarDadosProduto() {
        super();
    }

	protected void doGet(HttpServletRequest request, HttpServletResponse response) throws ServletException, IOException {
		try {
			if(request.getParameter("nome") != null && !request.getParameter("nome").isEmpty()){
				Produto p = Fachada.getFachada().buscarProduto(request.getParameter("nome"));
				
				String tipo = null;
				
				if(p instanceof Filme){
					tipo = "filme";
				} else if(p instanceof Documentario){
					tipo = "documentario";
				} else if(p instanceof Musica){
					tipo = "musica";
				} else if(p instanceof Serie){
					tipo = "serie";
				} else if(p instanceof Jogo){
					tipo = "jogo";
				}

				String resposta = "alterar-produto.jsp?type="+tipo + "&produto=" + p.getId();
				response.sendRedirect(resposta);
			} else {
				response.sendRedirect("cadastro-erro.jsp?tipo=produto&erro=campo");
			}
		} catch (NumberFormatException e) {
			response.sendRedirect("cadastro-erro.jsp?erro=campo");
		} catch (ServidorIndisponivelException e) {
			response.sendRedirect("erro-servidor.jsp");
		} catch (ProdutoInexistenteException e) {
			response.sendRedirect("cadastro-erro.jsp?erro=produtoInexistente");
		}
	}

	protected void doPost(HttpServletRequest request, HttpServletResponse response) throws ServletException, IOException {
		this.doGet(request, response);
	}

}
