package servlets;

import java.io.IOException;
import javax.servlet.ServletException;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import negocio.exception.FilialInexistenteException;
import negocio.exception.UsuarioNaoLogadoException;
import negocio.exception.UsuarioSemPermissaoException;
import util.Util;
import dados.exception.EnderecoInvalidoException;
import dados.exception.FilialInvalidaException;
import dados.exception.TelefoneInvalidoException;
import dados.filial.Endereco;
import dados.filial.Filial;
import dados.usuario.Telefone;
import exception.ServidorIndisponivelException;
import fachada.Fachada;

/**
 * Servlet implementation class AlterarFilial
 */
public class AlterarFilial extends HttpServlet {
	private static final long serialVersionUID = 1L;
       
    public AlterarFilial() {
        super();
    }

	protected void doGet(HttpServletRequest request, HttpServletResponse response) throws ServletException, IOException {
		if(request.getSession().getAttribute("sessao") != null){
			try {
				Endereco e = new Endereco(Util.htmlToString(request.getParameter("logradouro")), Util.htmlToString(request.getParameter("estado")), Util.htmlToString(request.getParameter("cidade")), Util.htmlToString(request.getParameter("bairro")), Util.htmlToString(request.getParameter("complemento")), Integer.parseInt(request.getParameter("numero")), Integer.parseInt(request.getParameter("cep").replace("-", "")));
				Telefone t = new Telefone(Integer.parseInt(request.getParameter("dddtelefone")), Integer.parseInt(request.getParameter("telefone").replace("-", "")));
				Filial filial = new Filial(request.getParameter("nome").trim(), t, e);

				Fachada.getFachada().alterarFilial((Long)request.getSession().getAttribute("sessao"), filial);
				response.sendRedirect("cadastro-concluido.jsp?tipo=filial");
			} catch (NumberFormatException e) {
				response.sendRedirect("cadastro-erro.jsp?tipo=filial&erro=campo");
			} catch (EnderecoInvalidoException e) {
				response.sendRedirect("cadastro-erro.jsp?tipo=filial&erro=endereco");
			} catch (NullPointerException e) {
				response.sendRedirect("cadastro-erro.jsp?tipo=filial&erro=campo");
			} catch (TelefoneInvalidoException e) {
				response.sendRedirect("cadastro-erro.jsp?tipo=filial&erro=telefone");
			} catch (FilialInvalidaException e) {
				response.sendRedirect("cadastro-erro.jsp?tipo=filial&erro=campo");
			} catch (UsuarioNaoLogadoException e) {
				response.sendRedirect("cadastro-erro.jsp?tipo=produto&erro=usuarioNaoLogado");
			} catch (UsuarioSemPermissaoException e) {
				response.sendRedirect("cadastro-erro.jsp?tipo=filial&erro=permissaoNegada");
			} catch (ServidorIndisponivelException e) {
				response.sendRedirect("erro-servidor.jsp");
			} catch (FilialInexistenteException e) {
				response.sendRedirect("cadastro-erro.jsp?tipo=filial&erro=filialInexistente");
			}


		}else{
			response.sendRedirect("index.jsp");
		}
	}

	protected void doPost(HttpServletRequest request, HttpServletResponse response) throws ServletException, IOException {
		this.doGet(request, response);
	}

}
