package servlets;

import java.io.IOException;
import javax.servlet.ServletException;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import negocio.exception.SenhaInvalidaException;
import negocio.exception.UsuarioExistenteException;
import negocio.exception.UsuarioInexistenteException;
import negocio.exception.UsuarioNaoLogadoException;
import negocio.exception.UsuarioSemPermissaoException;

import dados.usuario.Usuario;
import exception.ServidorIndisponivelException;
import fachada.Fachada;

/**
 * Servlet implementation class AlterarSenha
 */
public class AlterarSenha extends HttpServlet {
	private static final long serialVersionUID = 1L;
       
    public AlterarSenha() {
        super();
    }

	protected void doGet(HttpServletRequest request, HttpServletResponse response) throws ServletException, IOException {
		try {
			Usuario user = Fachada.getFachada().getUsuario((Long) request.getSession().getAttribute("sessao"), (Long) request.getSession().getAttribute("login"));
			if(request.getParameter("senhaatual").equals(user.getSenha())){
				if(request.getParameter("senha").equals(request.getParameter("senha2"))){
					user.setSenha(request.getParameter("senha"));
					Fachada.getFachada().alterarDadosUsuario((Long) request.getSession().getAttribute("sessao"), user);
					response.sendRedirect("cadastro-concluido.jsp?tipo=alterarSenha");
				} else {
					response.sendRedirect("cadastro-erro.jsp?erro=senhaDiferente");
				}
			} else {
				response.sendRedirect("cadastro-erro.jsp?erro=senhaIncorreta");
			}
		} catch (UsuarioNaoLogadoException e) {
			response.sendRedirect("cadastro-erro.jsp?tipo=produto&erro=usuarioNaoLogado");
		} catch (UsuarioInexistenteException e) {
			e.printStackTrace();
			response.sendRedirect("index.jsp");
		} catch (UsuarioSemPermissaoException e) {
			e.printStackTrace();
			response.sendRedirect("index.jsp");
		} catch (ServidorIndisponivelException e) {
			response.sendRedirect("erro-servidor.jsp");
		} catch (SenhaInvalidaException e) {
			response.sendRedirect("cadastro-erro.jsp?erro=senha");
		} catch (UsuarioExistenteException e) {
			e.printStackTrace();
			response.sendRedirect("index.jsp");
		}
	}

	protected void doPost(HttpServletRequest request, HttpServletResponse response) throws ServletException, IOException {
		this.doGet(request, response);
	}

}
