package servlets;

import java.io.IOException;
import javax.servlet.ServletException;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import negocio.exception.ProdutoInexistenteException;
import negocio.exception.UsuarioInexistenteException;
import negocio.exception.UsuarioNaoLogadoException;
import negocio.exception.UsuarioSemPermissaoException;

import dados.exception.AvaliacaoInvalidaException;
import dados.produto.AvaliacaoProduto;
import dados.produto.Produto;
import exception.ServidorIndisponivelException;

import fachada.Fachada;

public class AvaliarProduto extends HttpServlet {
	
	private static final long serialVersionUID = 1L;
       
    public AvaliarProduto() {
        super();
    }

	protected void doGet(HttpServletRequest request, HttpServletResponse response) throws ServletException, IOException {
		if(request.getSession().getAttribute("sessao") != null){
			Long sessao = (Long) request.getSession().getAttribute("sessao");
			
			try {
				Produto p = Fachada.getFachada().buscarProduto(Long.parseLong(request.getParameter("produto")));
				AvaliacaoProduto a = new AvaliacaoProduto(Integer.parseInt(request.getParameter("nota")), request.getParameter("recomendacao").equals("SIM"), request.getParameter("comentarios").trim(), Fachada.getFachada().getUsuario(sessao, (Long)request.getSession().getAttribute("login")), p);
				
				Fachada.getFachada().inserirAvaliacao(sessao, a);
				response.sendRedirect("produto.jsp?id="+request.getParameter("produto"));
			} catch (NumberFormatException e) {
				response.sendRedirect("cadastro-erro.jsp?tipo=avaliacao&erro=campo");
			} catch (NullPointerException e) {
				response.sendRedirect("cadastro-erro.jsp?tipo=avaliacao&erro=campo");
			} catch (AvaliacaoInvalidaException e) {
				response.sendRedirect("cadastro-erro.jsp?tipo=avaliacao&erro=campo");
			} catch (UsuarioNaoLogadoException e) {
				response.sendRedirect("cadastro-erro.jsp?tipo=produto&erro=usuarioNaoLogado");
			} catch (UsuarioInexistenteException e) {
				response.sendRedirect("index.jsp");
			} catch (UsuarioSemPermissaoException e) {
				response.sendRedirect("cadastro-erro.jsp?tipo=avaliacao&erro=permissaoNegada");
			} catch (ServidorIndisponivelException e) {
				response.sendRedirect("erro-servidor.jsp");
			} catch (ProdutoInexistenteException e) {
				response.sendRedirect("cadastro-erro.jsp?tipo=avaliacao&erro=produtoInexistente");
			}
		}else{
			response.sendRedirect("index.jsp");
		}
	}

	protected void doPost(HttpServletRequest request, HttpServletResponse response) throws ServletException, IOException {
		this.doGet(request, response);
	}

}
