package servlets;

import java.io.IOException;
import javax.servlet.ServletException;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import negocio.exception.ClassificacaoExistenteException;
import negocio.exception.UsuarioNaoLogadoException;
import negocio.exception.UsuarioSemPermissaoException;

import dados.exception.PrecoInvalidoException;
import dados.produto.ClassificacaoPreco;
import dados.produto.ClassificacaoPrecoInvalida;
import exception.ServidorIndisponivelException;

import fachada.Fachada;

public class CadastroCategoria extends HttpServlet {
	private static final long serialVersionUID = 1L;

	public CadastroCategoria() {
		super();
	}

	protected void doGet(HttpServletRequest request, HttpServletResponse response) throws ServletException, IOException {
		Object o = request.getSession().getAttribute("sessao");

		if(o != null){
			Long sessao = (Long) o;

			try {
				ClassificacaoPreco c = new ClassificacaoPreco(request.getParameter("nome"), Double.parseDouble(request.getParameter("preco")));
				Fachada.getFachada().cadastrarClassificacao(sessao, c);
				response.sendRedirect("cadastro-concluido.jsp?tipo=classificacao");
			} catch (NumberFormatException e) {
				response.sendRedirect("cadastro-erro.jsp?tipo=classificacao&erro=campos");
			} catch (PrecoInvalidoException e) {
				response.sendRedirect("cadastro-erro.jsp?tipo=classificacao&erro=preco");
			} catch (ClassificacaoPrecoInvalida e) {
				response.sendRedirect("cadastro-erro.jsp?tipo=classificacao&erro=descricao");
			} catch (ServidorIndisponivelException e) {
				response.sendRedirect("erro-servidor.jsp");
			} catch (UsuarioNaoLogadoException e) {
				response.sendRedirect("cadastro-erro.jsp?tipo=produto&erro=usuarioNaoLogado");
			} catch (ClassificacaoExistenteException e) {
				response.sendRedirect("cadastro-erro.jsp?tipo=classificacao&erro=classificacaoExistente");
			} catch (UsuarioSemPermissaoException e) {
				response.sendRedirect("cadastro-erro.jsp?tipo=classificacao&erro=permissaoNegada");
			}
		}
	}

	protected void doPost(HttpServletRequest request, HttpServletResponse response) throws ServletException, IOException {
		this.doGet(request, response);
	}

}
