package servlets;

import java.io.IOException;
import java.util.Random;

import javax.servlet.ServletException;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import util.Util;

import negocio.exception.PlanoInexistenteException;
import negocio.exception.SenhaInvalidaException;
import negocio.exception.UsuarioExistenteException;

import dados.exception.CpfInvalidoException;
import dados.exception.EmailInvalidoException;
import dados.exception.EnderecoInvalidoException;
import dados.exception.NomeInvalidoException;
import dados.exception.PlanoInvalidoException;
import dados.exception.TelefoneInvalidoException;
import dados.filial.Endereco;
import dados.usuario.Cliente;
import dados.usuario.Plano;
import dados.usuario.Telefone;
import exception.ServidorIndisponivelException;
import fachada.Fachada;

public class CadastroCliente extends HttpServlet {
	
	private static final long serialVersionUID = 1L;
       
    public CadastroCliente() {
        super();
    }

	protected void doGet(HttpServletRequest request, HttpServletResponse response) throws ServletException, IOException {
		if(request.getSession().getAttribute("sessao") == null){
			try {
				Plano plano = Fachada.getFachada().procurarPlano(Long.parseLong(request.getParameter("plano")));
				Cliente cliente = new Cliente(Long.parseLong(request.getParameter("cpf").replace("-", "")),this.gerarSenha(), Util.htmlToString(request.getParameter("nome")), Util.htmlToString(request.getParameter("email")), plano, new Endereco(Util.htmlToString(request.getParameter("logradouro")), Util.htmlToString(request.getParameter("estado")), Util.htmlToString(request.getParameter("cidade")), Util.htmlToString(request.getParameter("bairro")), Util.htmlToString(request.getParameter("complemento")), Integer.parseInt(request.getParameter("numero")), Integer.parseInt(request.getParameter("cep").replace("-", ""))));
				
				Telefone t = new Telefone(Integer.parseInt(request.getParameter("dddtelefone")), Integer.parseInt(request.getParameter("telefone").replace("-", ""))), t2 = null;
				
				if(request.getParameter("dddtelefone2") != null && !request.getParameter("dddtelefone2").isEmpty() && request.getParameter("telefone2") != null && !request.getParameter("telefone2").isEmpty()){
					t2 = new Telefone(Integer.parseInt(request.getParameter("dddtelefone2")), Integer.parseInt(request.getParameter("telefone2").replace("-", "")));
				}
				
				Telefone[] tarray = new Telefone[t2 == null ? 1 : 2];
				tarray[0] = t;
				
				if(t2 != null){
					tarray[1] = t2;
				}
				
				Fachada.getFachada().cadastrarCliente(cliente, tarray);
				response.sendRedirect("cadastro-concluido.jsp?tipo=usuario&email="+request.getParameter("email"));
			} catch (NumberFormatException e) {
				response.sendRedirect("cadastro-erro.jsp?erro=campo");
			} catch (EmailInvalidoException e) {
				response.sendRedirect("cadastro-erro.jsp?erro=email");
			} catch (EnderecoInvalidoException e) {
				response.sendRedirect("cadastro-erro.jsp?erro=endereco");
			} catch (PlanoInexistenteException e) {
				response.sendRedirect("cadastro-erro.jsp?erro=plano");
			} catch (ServidorIndisponivelException e) {
				response.sendRedirect("erro-servidor.jsp");
			} catch (UsuarioExistenteException e) {
				response.sendRedirect("cadastro-erro.jsp?tipo=usuario&erro=replica");
			} catch (TelefoneInvalidoException e) {
				response.sendRedirect("cadastro-erro.jsp?erro=telefone");
			} catch (NomeInvalidoException e) {
				response.sendRedirect("cadastro-erro.jsp?erro=nome");
			} catch (SenhaInvalidaException e) {
				response.sendRedirect("cadastro-erro.jsp?erro=senha");
			} catch (CpfInvalidoException e) {
				response.sendRedirect("cadastro-erro.jsp?erro=cpf");
			} catch (PlanoInvalidoException e) {
				response.sendRedirect("erro-servidor.jsp");
			}
		}else{
			response.sendRedirect("index.jsp");
		}
	}

	private String gerarSenha() {
		String s = "password";
		return s + new Random().nextInt(100000);
	}

	protected void doPost(HttpServletRequest request, HttpServletResponse response) throws ServletException, IOException {
		this.doGet(request, response);
	}

}
