package servlets;

import java.io.IOException;
import javax.servlet.ServletException;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import negocio.exception.CopiaExistenteException;
import negocio.exception.FilialInexistenteException;
import negocio.exception.ProdutoInexistenteException;
import negocio.exception.UsuarioNaoLogadoException;
import negocio.exception.UsuarioSemPermissaoException;
import dados.exception.CopiaInvalidaException;
import dados.locacao.Copia;
import exception.ServidorIndisponivelException;
import fachada.Fachada;

/**
 * Servlet implementation class CadastroCopia
 */
public class CadastroCopia extends HttpServlet {
	private static final long serialVersionUID = 1L;
       
    public CadastroCopia() {
        super();
    }

	protected void doGet(HttpServletRequest request, HttpServletResponse response) throws ServletException, IOException {
Object o = request.getSession().getAttribute("sessao");
		
		if(o != null){
			Long sessao = (Long) o;
			try {
				Fachada fachada =  Fachada.getFachada(); 
				Copia copia = new Copia(Integer.parseInt(request.getParameter("codigo")), fachada.getFilial(request.getParameter("filial")), fachada.buscarProduto(request.getParameter("produto")));
				Fachada.getFachada().cadastrarCopia(sessao, copia);
				
				response.sendRedirect("cadastro-concluido.jsp?tipo=copia");
			} catch (NumberFormatException e) {
				response.sendRedirect("cadastro-erro.jsp?tipo=copia&erro=campo");
			} catch (UsuarioSemPermissaoException e) {
				response.sendRedirect("cadastro-erro.jsp?tipo=copia&erro=permissaoNegada");
			} catch (UsuarioNaoLogadoException e) {
				response.sendRedirect("cadastro-erro.jsp?tipo=produto&erro=usuarioNaoLogado");
			} catch (ServidorIndisponivelException e) {
				response.sendRedirect("erro-servidor.jsp");
			} catch (NullPointerException e){
				e.printStackTrace();
				response.sendRedirect("index.jsp");
			} catch (CopiaInvalidaException e) {
				response.sendRedirect("cadastro-erro.jsp?tipo=copia&erro=copiaInvalida");
			} catch (FilialInexistenteException e) {
				response.sendRedirect("index.jsp");
			} catch (ProdutoInexistenteException e) {
				response.sendRedirect("cadastro-erro.jsp?tipo=copia&erro=produtoInexistente");
			} catch (CopiaExistenteException e) {
				response.sendRedirect("cadastro-erro.jsp?tipo=copia&erro=copiaExistente");
			}
		}else{
			response.sendRedirect("index.jsp");
		}
	}

	protected void doPost(HttpServletRequest request, HttpServletResponse response) throws ServletException, IOException {
		this.doGet(request, response);
	}

}
