package servlets;

import java.io.IOException;
import javax.servlet.ServletException;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import util.Util;

import dados.exception.CpfInvalidoException;
import dados.exception.EmailInvalidoException;
import dados.exception.FilialInvalidaException;
import dados.exception.NomeInvalidoException;
import dados.usuario.Administrador;
import dados.usuario.Cliente;
import dados.usuario.Dependente;
import dados.usuario.Funcionario;
import dados.usuario.Usuario;

import negocio.exception.FilialInexistenteException;
import negocio.exception.SenhaInvalidaException;
import negocio.exception.UsuarioExistenteException;
import negocio.exception.UsuarioInexistenteException;
import negocio.exception.UsuarioNaoLogadoException;
import negocio.exception.UsuarioSemPermissaoException;
import exception.ServidorIndisponivelException;
import fachada.Fachada;

/**
 * Servlet implementation class CadastroUsuario
 */
public class CadastroUsuario extends HttpServlet {
	private static final long serialVersionUID = 1L;

	public CadastroUsuario() {
		super();
	}

	protected void doGet(HttpServletRequest request, HttpServletResponse response) throws ServletException, IOException {
		Object o = request.getSession().getAttribute("sessao");

		if(o != null){
			Long sessao = (Long) o;

			try {
				Usuario user = null;
				Fachada fachada = Fachada.getFachada();

				if(request.getParameter("password") != null && request.getParameter("password2") != null){
					if(request.getParameter("password").equals(request.getParameter("password2"))){
						if(request.getParameter("tipo") != null){
							if(request.getParameter("tipo").equals("dependente")){ //Eh um dependente
								user = new Dependente(Long.parseLong(request.getParameter("cpf").replace("-", "")),request.getParameter("password"), Util.htmlToString(request.getParameter("nome")), Util.htmlToString(request.getParameter("email")), (Cliente) fachada.getUsuario(sessao, Long.parseLong(Util.htmlToString(request.getParameter("cpf-cliente")))));
							} else if(request.getParameter("tipo").equals("funcionario")){ //Eh um funcionario
								user = new Funcionario(Long.parseLong(request.getParameter("cpf").replace("-", "")),request.getParameter("password"), Util.htmlToString(request.getParameter("nome")), Util.htmlToString(request.getParameter("email")), fachada.getFilial(Util.htmlToString(request.getParameter("filial"))));
							} else  if(request.getParameter("tipo").equals("administrador")){ // Eh um administrador
								user = new Administrador(Long.parseLong(request.getParameter("cpf").replace("-", "")),request.getParameter("password"), Util.htmlToString(request.getParameter("nome")), Util.htmlToString(request.getParameter("email")));
							} else {
								response.sendRedirect("cadastro-erro.jsp?tipo=usuario&erro=campo");
							}
						} else {
							response.sendRedirect("cadastro-erro.jsp?tipo=usuario&erro=campo");
						}

						if(user != null){
							Fachada.getFachada().cadastrarUsuario(sessao, user);
							response.sendRedirect("cadastro-concluido.jsp?tipo=usuario&subtipo=" + request.getParameter("tipo"));
						} else {
							response.sendRedirect("cadastro-erro.jsp?tipo=usuario&erro=campo");
						}
					} else {
						response.sendRedirect("cadastro-erro.jsp?tipo=usuario&erro=senhaDiferente");
					}
				} else {
					response.sendRedirect("cadastro-erro.jsp?tipo=usuario&erro=senha");
				}

			} catch (NumberFormatException e) {
				response.sendRedirect("cadastro-erro.jsp?tipo=usuario&erro=campo");
			} catch (UsuarioSemPermissaoException e) {
				response.sendRedirect("cadastro-erro.jsp?tipo=usuario&erro=permissaoNegada");
			} catch (UsuarioNaoLogadoException e) {
				response.sendRedirect("cadastro-erro.jsp?tipo=produto&erro=usuarioNaoLogado");
			} catch (ServidorIndisponivelException e) {
				response.sendRedirect("erro-servidor.jsp");
			} catch (NullPointerException e){
				e.printStackTrace();
				response.sendRedirect("index.jsp");
			} catch (UsuarioExistenteException e) {
				response.sendRedirect("cadastro-erro.jsp?tipo=usuario&erro=replica");
			} catch (NomeInvalidoException e) {
				response.sendRedirect("cadastro-erro.jsp?tipo=usuario&erro=nome");
			} catch (SenhaInvalidaException e) {
				response.sendRedirect("cadastro-erro.jsp?tipo=usuario&erro=senha");
			} catch (CpfInvalidoException e) {
				response.sendRedirect("cadastro-erro.jsp?tipo=usuario&erro=cpf");
			} catch (EmailInvalidoException e) {
				response.sendRedirect("cadastro-erro.jsp?tipo=usuario&erro=email");
			} catch (FilialInvalidaException e) {
				e.printStackTrace();
				response.sendRedirect("index.jsp");
			} catch (FilialInexistenteException e) {
				e.printStackTrace();
				response.sendRedirect("index.jsp");
			} catch (UsuarioInexistenteException e) {
				response.sendRedirect("cadastro-erro.jsp?tipo=usuario&erro=clienteInexistente");
			}
		}else{
			response.sendRedirect("index.jsp");
		}
	}

	protected void doPost(HttpServletRequest request, HttpServletResponse response) throws ServletException, IOException {
		this.doGet(request, response);
	}

}
