package servlets;

import java.io.IOException;
import java.util.Vector;

import javax.servlet.ServletException;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import negocio.exception.CopiaInexistenteException;
import negocio.exception.CopiaLocadaNoPeriodoException;
import negocio.exception.CopiaReservadaNoPeriodoException;
import negocio.exception.FilialInexistenteException;
import negocio.exception.FilialNaoLogadaException;
import negocio.exception.ProdutoInexistenteException;
import negocio.exception.ReservaExistenteException;
import negocio.exception.UsuarioInexistenteException;
import negocio.exception.UsuarioNaoLogadoException;
import negocio.exception.UsuarioSemPermissaoException;

import dados.exception.PeriodoInvalidoException;
import dados.exception.ReservaInvalidaException;
import dados.locacao.Copia;
import dados.usuario.Cliente;
import exception.ServidorIndisponivelException;
import fachada.Fachada;

public class InserirSacola extends HttpServlet {
	private static final long serialVersionUID = 1L;
       
    public InserirSacola() {
        super();
    }

	@SuppressWarnings("unchecked")
	protected void doGet(HttpServletRequest request, HttpServletResponse response) throws ServletException, IOException {
		Object o = request.getSession().getAttribute("sessao");
		
		if(o == null){
			response.sendRedirect("index.jsp");
		}else{
			if(request.getSession().getAttribute("tipo") != null && request.getSession().getAttribute("tipo") instanceof Cliente){
				Object w = request.getSession().getAttribute("sacola");
				
				try {
					Copia copia = Fachada.getFachada().getCopia(Long.parseLong(request.getParameter("id")), Long.parseLong(request.getParameter("produto")));
					Vector<Copia> c = null;
					
					if(w == null){
						c = new Vector<Copia>();
					}else{
						c = (Vector<Copia>) w;
					}
					
					if(c.contains(copia)){
						response.sendRedirect("cadastro-erro.jsp?erro=copiaNaSacola");
					}else{
						c.add(copia);
						Fachada.getFachada().reservarCopia((Long) request.getSession().getAttribute("sessao"), (Long) request.getSession().getAttribute("login"), copia);
						request.getSession().setAttribute("sacola", c);
						response.sendRedirect("cadastro-concluido.jsp?tipo=sacola");
					}
				} catch (NumberFormatException e) {
					e.printStackTrace();
					response.sendRedirect("index.jsp");
				} catch (CopiaInexistenteException e) {
					response.sendRedirect("cadastro-erro.jsp?erro=copiaInexistente");
				} catch (ProdutoInexistenteException e) {
					response.sendRedirect("cadastro-erro.jsp?erro=produtoInexistente");
				} catch (FilialInexistenteException e) {
					response.sendRedirect("cadastro-erro.jsp?erro=copiaFilialInexistente");
				} catch (ServidorIndisponivelException e) {
					response.sendRedirect("erro-servidor.jsp");
				} catch (UsuarioNaoLogadoException e) {
					e.printStackTrace();
					response.sendRedirect("index.jsp");
				} catch (ReservaExistenteException e) {
					response.sendRedirect("cadastro-erro.jsp?erro=copiaIndisponivel");
				} catch (UsuarioSemPermissaoException e) {
					e.printStackTrace();
					response.sendRedirect("index.jsp");
				} catch (CopiaLocadaNoPeriodoException e) {
					response.sendRedirect("cadastro-erro.jsp?erro=copiaIndisponivel");
				} catch (CopiaReservadaNoPeriodoException e) {
					response.sendRedirect("cadastro-erro.jsp?erro=copiaIndisponivel");
				} catch (ReservaInvalidaException e) {
					e.printStackTrace();
					response.sendRedirect("index.jsp");
				} catch (UsuarioInexistenteException e) {
					e.printStackTrace();
					response.sendRedirect("index.jsp");
				} catch (PeriodoInvalidoException e) {
					e.printStackTrace();
					response.sendRedirect("index.jsp");
				} catch (FilialNaoLogadaException e) {
					response.sendRedirect("cadastro-erro.jsp?erro=filialIndisponivel");
				}
			}else{
				response.sendRedirect("index.jsp");
			}
		}
	}

	protected void doPost(HttpServletRequest request, HttpServletResponse response) throws ServletException, IOException {
		this.doGet(request, response);
	}

}
