package servlets;

import java.io.IOException;
import java.util.Calendar;
import java.util.Vector;

import javax.servlet.ServletException;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import negocio.exception.CopiaLocadaNoPeriodoException;
import negocio.exception.CopiaReservadaNoPeriodoException;
import negocio.exception.FilialNaoLogadaException;
import negocio.exception.LocacaoExistenteException;
import negocio.exception.UsuarioInexistenteException;
import negocio.exception.UsuarioNaoLogadoException;
import negocio.exception.UsuarioSemPermissaoException;

import dados.exception.LocacaoInvalidaException;
import dados.exception.PeriodoInvalidoException;
import dados.locacao.Copia;
import dados.locacao.Locacao;
import dados.locacao.Periodo;
import dados.usuario.Cliente;
import exception.ServidorIndisponivelException;
import fachada.Fachada;

public class LocacaoDomicilio extends HttpServlet {
	private static final long serialVersionUID = 1L;
       
    public LocacaoDomicilio() {
        super();
    }

	@SuppressWarnings("unchecked")
	protected void doGet(HttpServletRequest request, HttpServletResponse response) throws ServletException, IOException {
		Object o = request.getSession().getAttribute("sessao");
		
		if(o != null && o instanceof Long){
			Long l = (Long) o;
			
			Object sac = request.getSession().getAttribute("sacola");
			
			if(sac != null && sac instanceof Vector<?>){
				Vector<Copia> sacola = (Vector<Copia>) sac;
				
				if(sacola.isEmpty()){
					response.sendRedirect("index.jsp");
				}else{
					Calendar c1 = Calendar.getInstance();
					Calendar c2 = Calendar.getInstance();
					int dias = Integer.parseInt(request.getParameter("dias"));
					c2.add(Calendar.DAY_OF_YEAR, Integer.parseInt(request.getParameter("dias")));
					c2.set(Calendar.HOUR_OF_DAY, 23);
					c2.set(Calendar.MINUTE, 59);
					
					int preco = 0;
					
					Periodo p = null;
					try {
						p = new Periodo(c1, c2);
					} catch (PeriodoInvalidoException e1) {
					}
					
					for(int i = 0; i < sacola.size() - 1; i++){
						try {
							Locacao loc = new Locacao((Cliente)Fachada.getFachada().getUsuario((Long)request.getSession().getAttribute("sessao"), (Long)request.getSession().getAttribute("login")), sacola.get(i), p);
							Fachada.getFachada().inserirLocacao(l, (Long) request.getSession().getAttribute("login"), loc);
							preco = (int) (preco + loc.getCopia().getProduto().getClassificacaoPreco().getPreco() * dias);
							sacola.remove(i);
							i--;
						} catch (LocacaoInvalidaException e) {
						} catch (UsuarioNaoLogadoException e) {
						} catch (UsuarioInexistenteException e) {
						} catch (UsuarioSemPermissaoException e) {
						} catch (ServidorIndisponivelException e) {
						} catch (LocacaoExistenteException e) {
						} catch (CopiaLocadaNoPeriodoException e) {
						} catch (CopiaReservadaNoPeriodoException e) {
						} catch (FilialNaoLogadaException e) {
						}
					}

					try{
						Locacao loc = new Locacao((Cliente)Fachada.getFachada().getUsuario((Long)request.getSession().getAttribute("sessao"), (Long)request.getSession().getAttribute("login")), sacola.get(sacola.size()-1), p);
						
						preco = preco + (int)((loc.getCopia().getProduto().getClassificacaoPreco().getPreco())*dias + Fachada.getTaxaEntrega());
						Fachada.getFachada().inserirLocacao(l, (Long) request.getSession().getAttribute("login"), loc);
						sacola.remove(sacola.size()-1);
					} catch (LocacaoInvalidaException e) {
					} catch (UsuarioNaoLogadoException e) {
					} catch (UsuarioInexistenteException e) {
					} catch (UsuarioSemPermissaoException e) {
					} catch (ServidorIndisponivelException e) {
					} catch (LocacaoExistenteException e) {
					} catch (CopiaLocadaNoPeriodoException e) {
					} catch (CopiaReservadaNoPeriodoException e) {
					} catch (FilialNaoLogadaException e) {
					}
					
					request.getSession().setAttribute("sacola", sacola);
					
					if(sacola.isEmpty()){
						response.sendRedirect("locacao-concluida.jsp?preco=" + preco);
					}else{
						response.sendRedirect("locacao-concluida.jsp?msg=verSacola&preco=" + String.format("%.2f",preco));
					}
				}
			}
		}else{
			response.sendRedirect("index.jsp");
		}
	}

	protected void doPost(HttpServletRequest request, HttpServletResponse response) throws ServletException, IOException {
		this.doGet(request, response);
	}

}
