package servlets;

import java.io.IOException;

import javax.servlet.ServletException;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import util.Util;

import dados.usuario.Usuario;

import negocio.exception.SenhaInvalidaException;
import negocio.exception.UsuarioInexistenteException;
import negocio.exception.UsuarioLogadoException;
import negocio.exception.UsuarioNaoLogadoException;
import negocio.exception.UsuarioSemPermissaoException;

import exception.ServidorIndisponivelException;
import fachada.Fachada;

public class LoginUsuario extends HttpServlet {
	private static final long serialVersionUID = 1L;

	public LoginUsuario() {
		super();
	}
	
	protected void doGet(HttpServletRequest request, HttpServletResponse response) throws ServletException, IOException {
		Object objeto = request.getSession().getAttribute("login");
		
		if(objeto != null){
			if(!(objeto instanceof Usuario)){
				throw new ServletException("A sesso Http contm um atributo invlido.");
			}
		}else{
			try {
				Long sessao = Fachada.getFachada().logarUsuario(Long.parseLong(request.getParameter("user").replace("-", "")), Util.htmlToString(request.getParameter("password")));
				request.getSession().setAttribute("sessao", sessao);
				request.getSession().setAttribute("login", Long.parseLong(request.getParameter("user").replace("-", "")));
				
				Usuario u = Fachada.getFachada().getUsuario(sessao, Long.parseLong(request.getParameter("user").replace("-", "")));
				
				request.getSession().setAttribute("tipo", u);
				
				request.getSession().setMaxInactiveInterval(600);
				response.sendRedirect("index.jsp");
			} catch (NumberFormatException e) {
				response.sendRedirect("login-erro.jsp?erro=campo");
			} catch (UsuarioLogadoException e) {
				response.sendRedirect("login-erro.jsp?erro=logado");
			} catch (UsuarioInexistenteException e) {
				response.sendRedirect("login-erro.jsp?erro=cpfinexistente");
			} catch (SenhaInvalidaException e) {
				response.sendRedirect("login-erro.jsp?erro=senha");
			} catch (ServidorIndisponivelException e) {
				response.sendRedirect("erro/erro-servidor.jsp");
			} catch (UsuarioNaoLogadoException e) {
				response.sendRedirect("erro/erro-servidor.jsp");
			} catch (UsuarioSemPermissaoException e) {
				response.sendRedirect("erro/erro-servidor.jsp");
			}
		}
	}

	protected void doPost(HttpServletRequest request, HttpServletResponse response) throws ServletException, IOException {
		this.doGet(request, response);
	}

}
