package servlets;

import java.io.IOException;
import java.rmi.RemoteException;

import javax.servlet.ServletException;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import javax.servlet.http.HttpSession;

import negocio.exception.UsuarioNaoLogadoException;

import exception.ServidorIndisponivelException;
import fachada.Fachada;

public class LogoffUsuario extends HttpServlet {
	private static final long serialVersionUID = 1L;
       
    public LogoffUsuario() {
        super();
    }

	protected void doGet(HttpServletRequest request, HttpServletResponse response) throws IOException {
		HttpSession h = request.getSession();
		Object obj = h.getAttribute("sessao");
		
		if(obj != null && obj instanceof Long){
			Long l = (Long) obj;
			
			try {
				Fachada.getFachada().logoff(l);
				h.invalidate();
				response.sendRedirect("index.jsp");
			} catch (UsuarioNaoLogadoException e) {
				response.sendRedirect("cadastro-erro.jsp?tipo=produto&erro=usuarioNaoLogado");
			} catch (ServidorIndisponivelException e) {
				response.sendRedirect("index.jsp");
			} catch (RemoteException e) {
				response.sendRedirect("erro-servidor.jsp");
			}
		}else{
			h.invalidate();
			response.sendRedirect("index.jsp");
		}
	}

	protected void doPost(HttpServletRequest request, HttpServletResponse response) throws ServletException, IOException {
		this.doGet(request, response);
	}

}
