package servlets;

import java.io.IOException;
import javax.servlet.ServletException;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import negocio.exception.CopiaInexistenteException;
import negocio.exception.ProdutoInexistenteException;
import negocio.exception.UsuarioNaoLogadoException;
import negocio.exception.UsuarioSemPermissaoException;
import exception.ServidorIndisponivelException;
import fachada.Fachada;

/**
 * Servlet implementation class RemocaoCopia
 */
public class RemocaoCopia extends HttpServlet {
	private static final long serialVersionUID = 1L;
       
    public RemocaoCopia() {
        super();
    }

	protected void doGet(HttpServletRequest request, HttpServletResponse response) throws ServletException, IOException {
		Object o = request.getSession().getAttribute("sessao");
		
		if(o != null){
			Long l = (Long) o;
			
			if(l != null){
				try {
					Fachada.getFachada().removerCopia(l, Integer.parseInt(request.getParameter("codigo")));
					response.sendRedirect("remocao-concluida.jsp?tipo=copia");
				} catch (UsuarioNaoLogadoException e) {
					response.sendRedirect("cadastro-erro.jsp?tipo=produto&erro=usuarioNaoLogado");
				} catch (UsuarioSemPermissaoException e) {
					response.sendRedirect("remocao-erro.jsp?tipo=copia&erro=permissaoNegada");
				} catch (ServidorIndisponivelException e) {
					response.sendRedirect("erro-servidor.jsp");
				} catch (NumberFormatException e) {
					response.sendRedirect("remocao-erro.jsp?tipo=copia&erro=campo");
				} catch (ProdutoInexistenteException e) {
					response.sendRedirect("remocao-erro.jsp?tipo=copia&erro=produtoInexistente");
				} catch (CopiaInexistenteException e) {
					response.sendRedirect("remocao-erro.jsp?tipo=copia&erro=copiaInexistente");
				}
			}
		}else{
			response.sendRedirect("index.jsp");
		}
	}

	protected void doPost(HttpServletRequest request, HttpServletResponse response) throws ServletException, IOException {
		this.doGet(request, response);
	}

}
