package servlets;

import java.io.IOException;
import javax.servlet.ServletException;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import negocio.exception.FilialInexistenteException;
import negocio.exception.UsuarioNaoLogadoException;
import negocio.exception.UsuarioSemPermissaoException;

import exception.ServidorIndisponivelException;
import fachada.Fachada;

public class RemocaoFilial extends HttpServlet {
	private static final long serialVersionUID = 1L;
       
    public RemocaoFilial() {
        super();
    }

	protected void doGet(HttpServletRequest request, HttpServletResponse response) throws ServletException, IOException {
		if(request.getSession().getAttribute("sessao") != null){
			Long sessao = (Long) request.getSession().getAttribute("sessao");
			
			try {
				Fachada.getFachada().removerFilial(sessao,request.getParameter("nome"));
				response.sendRedirect("remocao-concluida.jsp?tipo=filial");
			} catch (UsuarioNaoLogadoException e) {
				response.sendRedirect("cadastro-erro.jsp?tipo=produto&erro=usuarioNaoLogado");
			} catch (UsuarioSemPermissaoException e) {
				response.sendRedirect("remocao-erro.jsp?tipo=filial&erro=permissaoNegada");
			} catch (FilialInexistenteException e) {
				response.sendRedirect("remocao-erro.jsp?tipo=filial&erro=filialInexistente");
			} catch (ServidorIndisponivelException e) {
				response.sendRedirect("erro-servidor.jsp");
			} catch (NullPointerException e) {
				response.sendRedirect("remocao-erro.jsp?tipo=filial&erro=campo");
			}
		}
	}

	protected void doPost(HttpServletRequest request, HttpServletResponse response) throws ServletException, IOException {
		this.doGet(request, response);
	}

}
