package servlets;

import java.io.IOException;
import javax.servlet.ServletException;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import negocio.exception.ProdutoInexistenteException;
import negocio.exception.UsuarioNaoLogadoException;
import negocio.exception.UsuarioSemPermissaoException;

import util.Util;

import exception.ServidorIndisponivelException;
import fachada.Fachada;

public class RemocaoProduto extends HttpServlet {
	private static final long serialVersionUID = 1L;
       
    public RemocaoProduto() {
        super();
    }

	protected void doGet(HttpServletRequest request, HttpServletResponse response) throws ServletException, IOException {
		Object o = request.getSession().getAttribute("sessao");
		
		if(o != null){
			Long l = (Long) o;
			
			if(l != null){
				try {
					Fachada.getFachada().removerProduto(l, Util.htmlToString(request.getParameter("nome")));
					response.sendRedirect("remocao-concluida.jsp?tipo=produto");
				} catch (ProdutoInexistenteException e) {
					response.sendRedirect("remocao-erro.jsp?tipo=produto&erro=produtoInexistente");
				} catch (UsuarioNaoLogadoException e) {
					response.sendRedirect("cadastro-erro.jsp?tipo=produto&erro=usuarioNaoLogado");
				} catch (UsuarioSemPermissaoException e) {
					response.sendRedirect("remocao-erro.jsp?tipo=produto&erro=permissaoNegada");
				} catch (ServidorIndisponivelException e) {
					response.sendRedirect("erro-servidor.jsp");
				}
			}
		}else{
			response.sendRedirect("index.jsp");
		}
	}

	protected void doPost(HttpServletRequest request, HttpServletResponse response) throws ServletException, IOException {
		this.doGet(request, response);
	}

}
