package servlets;

import java.io.IOException;
import javax.servlet.ServletException;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import negocio.exception.SenhaInvalidaException;
import negocio.exception.UsuarioInexistenteException;
import negocio.exception.UsuarioNaoLogadoException;
import negocio.exception.UsuarioSemPermissaoException;

import exception.ServidorIndisponivelException;
import fachada.Fachada;

public class RemocaoUsuario extends HttpServlet {
	
	private static final long serialVersionUID = 1L;
       
    public RemocaoUsuario() {
        super();
    }

	protected void doGet(HttpServletRequest request, HttpServletResponse response) throws ServletException, IOException {
		Object o = request.getSession().getAttribute("sessao");
		
		if(o != null){
			Long sessao = (Long) o;
			try {
				String cpf = request.getParameter("cpf");
				String senha = request.getParameter("senha");
				
				if(cpf == null){
					cpf = Long.toString((Long)request.getSession().getAttribute("login"));
				}
			
				Fachada.getFachada().removerUsuario(sessao, Long.parseLong(cpf), senha);
				
				if(Long.parseLong(cpf) == (Long) request.getSession().getAttribute("login")){
					request.getSession().invalidate();
				}
				response.sendRedirect("remocao-concluida.jsp?tipo=usuario");
			} catch (NumberFormatException e) {
				response.sendRedirect("remocao-erro.jsp?tipo=usuario&erro=campo");
			} catch (UsuarioInexistenteException e) {
				response.sendRedirect("remocao-erro.jsp?tipo=usuario&erro=usuarioInexistente");
			} catch (UsuarioSemPermissaoException e) {
				response.sendRedirect("remocao-erro.jsp?tipo=usuario&erro=permissaoNegada");
			} catch (UsuarioNaoLogadoException e) {
				response.sendRedirect("cadastro-erro.jsp?tipo=produto&erro=usuarioNaoLogado");
			} catch (SenhaInvalidaException e) {
				response.sendRedirect("remocao-erro.jsp?tipo=usuario&erro=senhaErrada");
			} catch (ServidorIndisponivelException e) {
				response.sendRedirect("erro-servidor.jsp");
			}
		}else{
			response.sendRedirect("index.jsp");
		}
	}

	protected void doPost(HttpServletRequest request, HttpServletResponse response) throws ServletException, IOException {
		this.doGet(request, response);
	}

}
