package servlets;

import java.io.IOException;
import java.util.Vector;

import javax.servlet.ServletException;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import negocio.exception.CopiaInexistenteException;
import negocio.exception.ProdutoInexistenteException;
import negocio.exception.ReservaInexistenteException;
import negocio.exception.UsuarioInexistenteException;
import negocio.exception.UsuarioNaoLogadoException;
import negocio.exception.UsuarioSemPermissaoException;

import dados.locacao.Copia;
import dados.usuario.Cliente;
import exception.ServidorIndisponivelException;
import fachada.Fachada;

public class RemoverSacola extends HttpServlet {
	private static final long serialVersionUID = 1L;
       
    public RemoverSacola() {
        super();
    }

	@SuppressWarnings("unchecked")
	protected void doGet(HttpServletRequest request, HttpServletResponse response) throws ServletException, IOException {
		Object o = request.getSession().getAttribute("login");
		
		if(o != null){
			Object sac = request.getSession().getAttribute("sacola");
			
			if(sac != null && sac instanceof Vector<?>){
				Vector<Copia> sacola = (Vector<Copia>) sac;
				
				int codigo = Integer.parseInt(request.getParameter("id"));
				
				for(int i = 0; i < sacola.size(); i++){
					if(sacola.get(i).getCodigoCopia() == codigo){
						try {
							Fachada.getFachada().removerReserva((Long) request.getSession().getAttribute("sessao"), (Long)request.getSession().getAttribute("login"), sacola.get(i).getCodigoCopia());
						} catch (ReservaInexistenteException e) {
						} catch (UsuarioNaoLogadoException e) {
						} catch (UsuarioSemPermissaoException e) {
						} catch (UsuarioInexistenteException e) {
						} catch (CopiaInexistenteException e) {
						} catch (ProdutoInexistenteException e) {
						} catch (ServidorIndisponivelException e) {
						}

						sacola.remove(i);
					}
				}
				
				response.sendRedirect("compra.jsp");
			}else{
				response.sendRedirect("index.jsp");
			}
		}else{
			response.sendRedirect("index.jsp");
		}
	}

	protected void doPost(HttpServletRequest request, HttpServletResponse response) throws ServletException, IOException {
		this.doGet(request, response);
	}

}
